package fme;

import java.awt.*;
import javax.swing.*;

import java.lang.*;
import java.text.*;
import java.util.*;
import javax.swing.text.*;
import javax.swing.table.DefaultTableCellRenderer;
import java.net.URLEncoder;
import java.io.UnsupportedEncodingException;
import java.awt.event.*;

//------------------------------------------------------------------------------
// CFLib - ACESSO GLOBAL
//------------------------------------------------------------------------------

class CFLib {
  static CFType_Ano VLD_ANO = new CFType_Ano();
  static CFType_Ano VLD_ANO_CAND = new CFType_AnoCand();
  static CFType_Mes VLD_MES = new CFType_Mes();
  static CFType_AnoMes VLD_ANO_MES = new CFType_AnoMes();
  static CFType_Perc VLD_PERC = new CFType_Perc();
  static CFType_Perc0 VLD_PERC_0 = new CFType_Perc0();
  static CFType_Data VLD_DATA = new CFType_Data();

  static CFType_NumS VLD_NUM_S = new CFType_NumS();
  static CFType_Int VLD_INT = new CFType_Int();
  static CFType_Num VLD_NUM = new CFType_Num();
  static CFType_Num0 VLD_NUM_0 = new CFType_Num0();

  static CFType_ValorS VLD_VALOR_S = new CFType_ValorS();
  static CFType_Valor VLD_VALOR = new CFType_Valor();

  static CFType_ValorS0 VLD_VALOR_S0 = new CFType_ValorS0();
  static CFType_Valor0 VLD_VALOR_0 = new CFType_Valor0();

  static CFType_Nif VLD_NIF = new CFType_Nif();
  static CFType_Email VLD_EMAIL = new CFType_Email();
  static CFType_CodPostal VLD_COD_POSTAL = new CFType_CodPostal();
  static DefaultTableCellRenderer_RIGTH TCRenderer_Rigth = new
      DefaultTableCellRenderer_RIGTH();
  static DefaultTableCellRenderer_CENTER TCRenderer_Center = new
      DefaultTableCellRenderer_CENTER();

//  static ColorRenderer_Back TCRenderer_BackColor = new ColorRenderer_Back();
  static CHCampo_InputVerifier CHInputVerifier = new CHCampo_InputVerifier();
}

//------------------------------------------------------------------------------
// CFType_
//------------------------------------------------------------------------------

class CFType extends InternationalFormatter {
  CFType() { super(); }
  boolean setText(String _t) { return setText(_t, true); }
  boolean setText(String _t, boolean interact) { return false; }
  boolean setString(String _s) { return false; }
  boolean setValue(Object _v) { return false; }
  String getText() { return ""; }
  String getString() { return ""; }
  Object getValue() { return null; };
  boolean acceptKey(char c) { return true; };
  boolean isnull(String s) { return s.length() == 0; }
}

class CFTypeNumber extends CFType {
  CFTypeNumber() { super(); }

  DecimalFormat FMT;
  Number v;

  boolean setText(String _t, boolean interact) {

    v = null;
    //JOptionPane.showMessageDialog(null, "CValidate_Number, recebe: " + _t );
    try {
      v = FMT.parse(_t);
    }
    catch (Exception p) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Valor incorrecto.", "ERRO",
                                      JOptionPane.ERROR_MESSAGE);
      }
      return false;
    }
    return true;
  }

  // FILIPA
  boolean setString(String s) {
    if (s.length() == 0) {
      v = null;
      return true;
    }
    //v = new Double( Double.parseDouble(s) );
    v = new Long(Long.parseLong(s));
    //JOptionPane.showMessageDialog( null, "Recolhe: " + v.toString() );
    return true;
  }

  boolean setValue(Object _v) {
    v = (Number) _v;
    return true;
  }

  String getText() {
    if (v == null) { return "";};
    //JOptionPane.showMessageDialog( null, "getText - formatar <" + v.toString() + ">" );
    // geral ?
    if (v.doubleValue() == 0) { return ""; }
    return FMT.format(v);
  }

  //FILIPA
  String getString() {
    if (v == null) {
      return "";
    }
    if (v.doubleValue() == 0)
      return "";
    return _lib.to_string(v.doubleValue());
  }

  Object getValue() {
    return v;
  }

  boolean acceptKey(char c) {
    if (Character.isDigit(c)) {
      return true;
    }
    //if ( c == '-' || c == '.' || c == ',' ) return true;
    if (c == KeyEvent.VK_COMMA) {
      return true;
    }
    if (c == KeyEvent.VK_PERIOD) {
      return true;
    }
    if (c == KeyEvent.VK_MINUS) {
      return true;
    }
    return false;
  }
}

class CFType_Ano

    extends CFTypeNumber {
  CFType_Ano() {
    super();
    FMT = new DecimalFormat("####");
  }

  static int ano_inicial = 2007;
  static int ano_final = 2013;

  boolean setText(String _t, boolean interact) {
    boolean ok = super.setText(_t, interact);
    if (!ok) {
      return ok;
    }

    ok = _lib.is_digitsOnly(_t);
    if (!ok) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Valor incorrecto. " + _t, "Erro",
                                      JOptionPane.ERROR_MESSAGE);
      }
      return ok;
    }

    int n = ( (Number) v).intValue();

    //int n = Integer.parseInt( getString() );
    if (! (n >= ano_inicial && n <= ano_final )) {
      if (interact) {
        JOptionPane.showMessageDialog(null,
                                      "Valor de Ano invlido (" +
                                      Integer.toString(n) + ").", "Erro",
                                      JOptionPane.WARNING_MESSAGE);
      }
      return false;
    }
    return ok;
  }

  boolean acceptKey(char c) {
    return Character.isDigit(c);
  }

}

class CFType_AnoCand  extends CFType_Ano {
}

class CFType_Mes
    extends CFTypeNumber {
  CFType_Mes() {
    super();
    FMT = new DecimalFormat("00");
  }

  boolean setText(String _t, boolean interact) {

    //JOptionPane.showMessageDialog(null, "ano ? " + _t);
    boolean ok = super.setText(_t, interact);
    if (!ok) {
      return false;
    }

    ok = _lib.is_digitsOnly(_t);
    if (!ok) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Valor incorrecto.", "Erro",
                                      JOptionPane.WARNING_MESSAGE);
      }
      return ok;
    }

    int n = ( (Number) v).intValue();
    //int n = Integer.parseInt( getString() );
    if (! (n >= 1 && n <= 12)) {
      if (interact) {
        JOptionPane.showMessageDialog(null,
                                      "Valor de Ms invlido " +
                                      Integer.toString(n) + ".", "Erro",
                                      JOptionPane.WARNING_MESSAGE);
      }
      return false;
    }
    return ok;
  }

  String getString() {
    if (v == null) {
      return "";
    }
    //JOptionPane.showMessageDialog(null, "Mes: " + getText() );
    return getText();
  }

  boolean isnull(String _t) {
    Number x = null;
    try {
      x = FMT.parse(_t);
    }
    catch (Exception p) {
      return false;
    }
    if (x.doubleValue() == 0) {
      return true;
    }
    return false;
  }

}

class CFType_Perc extends CFTypeNumber {
  CFType_Perc() {
    super();
    FMT = new DecimalFormat("#0.00");
  }

  boolean setText(String _t, boolean interact) {
    boolean ok = super.setText(_t, interact);
    if (!ok) {
      return false;
    }

    ok = _lib.is_perc(_t, FMT.getDecimalFormatSymbols().getDecimalSeparator());
    if (!ok) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Valor incorrecto.", "Erro",
                                      JOptionPane.WARNING_MESSAGE);
      }
      return ok;
    }

    if (ok) {
      double d = ( (Number) v).doubleValue();
      if (! (d >= 0 && d <= 100)) {
        String msg = v + " - Valor invlido para este campo!\n" +
            "Por favor, introduza um valor entre 0,00 e 100,00.";
//         if ( interact) JOptionPane.showMessageDialog(null, "Valor de Percentagem invlido", "Erro", JOptionPane.WARNING_MESSAGE);
        if (interact) {
          JOptionPane.showMessageDialog(null, msg, "Percentagem invlida",
                                        JOptionPane.WARNING_MESSAGE);
        }
        return false;
      }
    }
    return true;
  }

  //FILIPA
  boolean setString(String s) {
    if (s.length() == 0) {
      v = null;
      return true;
    }
    v = new Double(Double.parseDouble(s));
    //JOptionPane.showMessageDialog( null, "Recolhe: " + v.toString() );
    return true;
  }

  boolean acceptKey(char c) {
    if (Character.isDigit(c)) {
      return true;
    }
    if (c == KeyEvent.VK_COMMA) {
      return true;
    }
    if (c == KeyEvent.VK_PERIOD) {
      return true;
    }
    return false;
  }

  boolean isnull(String _t) {
    Number x = null;
    try {
      x = FMT.parse(_t);
    }
    catch (Exception p) {
      return false;
    }
    if (x.doubleValue() == 0) {
      return true;
    }
    return false;
  }

}

class CFType_Perc0 extends CFTypeNumber {
	  CFType_Perc0() {
	    super();
	    FMT = new DecimalFormat("#0.00");
	  }

	  boolean setText(String _t, boolean interact) {
	    boolean ok = super.setText(_t, interact);
	    if (!ok) {
	      return false;
	    }

	    ok = _lib.is_perc(_t, FMT.getDecimalFormatSymbols().getDecimalSeparator());
	    if (!ok) {
	      if (interact) {
	        JOptionPane.showMessageDialog(null, "Valor incorrecto.", "Erro",
	                                      JOptionPane.WARNING_MESSAGE);
	      }
	      return ok;
	    }

	    if (ok) {
	      double d = ( (Number) v).doubleValue();
	      if (! (d >= 0 && d <= 100)) {
	        String msg = v + " - Valor invlido para este campo!\n" +
	            "Por favor, introduza um valor entre 0,00 e 100,00.";
//	         if ( interact) JOptionPane.showMessageDialog(null, "Valor de Percentagem invlido", "Erro", JOptionPane.WARNING_MESSAGE);
	        if (interact) {
	          JOptionPane.showMessageDialog(null, msg, "Percentagem invlida",
	                                        JOptionPane.WARNING_MESSAGE);
	        }
	        return false;
	      }
	    }
	    return true;
	  }


	  boolean acceptKey(char c) {
	    if (Character.isDigit(c)) {
	      return true;
	    }
	    if (c == KeyEvent.VK_COMMA) {
	      return true;
	    }
	    if (c == KeyEvent.VK_PERIOD) {
	      return true;
	    }
	    return false;
	  }

	  boolean isnull(String _t) {
		    Number x = null;
		    try {
		      x = FMT.parse(_t);
		    }
		    catch (Exception p) {
		      return false;
		    }
		    //if ( x.doubleValue() == 0 ) return true;
		    return false;
		  }

		  String getText() {
		    if (v == null) {
		      return "";
		    }
		    ;
		    if (v.doubleValue() == 0) {
		      return "0";
		    }
		    return super.getText();
		  }

		  // FILIPA
		  boolean setString(String s) {
		    if (s.length() == 0) {
		      v = null;
		      return true;
		    }
		    v = new Double(Double.parseDouble(s));
		    //JOptionPane.showMessageDialog( null, "Recolhe: " + v.toString() );
		    return true;
		  }

		  //FILIPA
		  String getString() {
		    if (v == null) {
		      return "";
		    }
		    return _lib.to_string(v.doubleValue());
		  }

}

class CFType_NumS
    extends CFTypeNumber {
  CFType_NumS() {
    super();
    FMT = new DecimalFormat("#0");
  }

  boolean setText(String _t, boolean interact) {
    boolean ok = super.setText(_t, interact);
    if (!ok) {
      return false;
    }

    ok = _lib.is_number(_t, FMT.getDecimalFormatSymbols().getGroupingSeparator());
    if (!ok) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Valor incorrecto.", "Erro",
                                      JOptionPane.WARNING_MESSAGE);
      }
      return ok;
    }
    return ok;
  }

}

class CFType_Num
    extends CFType_NumS {
  CFType_Num() {
    super();
    FMT = new DecimalFormat("#");
  }

  boolean setText(String _t, boolean interact) {
    boolean ok = super.setText(_t, interact);
    if (!ok) {
      return false;
    }

    int n = ( (Number) v).intValue();
    if (n <= 0) {
      if (interact) {
        JOptionPane.showMessageDialog(null,
                                      "Valor invlido (" + Integer.toString(n) +
                                      ").\n"
                                      +
                                      "Deve indicar um valor superior a zero!",
                                      "Erro",
                                      JOptionPane.ERROR_MESSAGE);
      }
      return false;
    }
    return ok;
  }

  boolean isnull(String _t) {
    Number x = null;
    try {
      x = FMT.parse(_t);
    }
    catch (Exception p) {
      return false;
    }
    if (x.doubleValue() == 0) {
      return true;
    }
    return false;
  }
}

class CFType_Num0 extends CFTypeNumber {
  CFType_Num0() {
    super();
    FMT = new DecimalFormat("#0");
  }

  boolean setText(String _t, boolean interact) {
    //JOptionPane.showMessageDialog(null, "setText num0");
    boolean ok = super.setText(_t, interact);
    if (!ok) {
      return false;
    }
    ok = _lib.is_number(_t, FMT.getDecimalFormatSymbols().getGroupingSeparator());
    if (!ok) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Valor incorrecto.", "Erro",
                                      JOptionPane.WARNING_MESSAGE);
      }
      return ok;
    }

    int n = ( (Number) v).intValue();
    if (n < 0) {
      if (interact) {
        JOptionPane.showMessageDialog(null,
                                      "Valor invlido (" + Integer.toString(n) +
                                      ").\n"
                                      + "O valor no pode ser negativo!",
                                      "Erro",
                                      JOptionPane.ERROR_MESSAGE);
      }
      return false;
    }
    return ok;
  }

  //FILIPA
  boolean setString (String s) {
    if ( s.length() == 0 ) {
      v = null;
      return true;
    }
    if ( s.indexOf('.') > 0)
      s = s.substring(0, s.indexOf('.') );
    super.setString(s);
    return true;
  }

  //FILIPA
  String getString() {
    if (v == null) {
      return "";
    }
    return _lib.to_string(v.doubleValue());
  }

  boolean isnull(String _t) {
    Number x = null;
    try {
      x = FMT.parse(_t);
    }
    catch (Exception p) {
      return false;
    }
    //if (x.doubleValue() == 0)return true;
    return false;
  }

  String getText() {
    if ( v == null ) { return "";};
    //JOptionPane.showMessageDialog( null, "getText - formatar <" + v.toString() + ">" );
    // geral ?
    if ( v.doubleValue() == 0) return "0";
    //return FMT.format(v);
    return super.getText();
  }


}

class CFType_Int
    extends CFTypeNumber {
  CFType_Int() {
    super();
    FMT = new DecimalFormat("#");
  }

  boolean setText(String _t, boolean interact) {
    boolean ok = super.setText(_t, interact);
    if (!ok) {
      return false;
    }

    ok = _lib.is_digitsOnly(_t);
    if (!ok) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Valor incorrecto. " + _t, "Erro",
                                      JOptionPane.WARNING_MESSAGE);
      }
      return ok;
    }

    return ok;
  }

  boolean acceptKey(char c) {
    if (Character.isDigit(c)) {
      return true;
    }
    return false;
  }
}

class CFType_ValorS extends CFTypeNumber {
  CFType_ValorS() {
    super();
    FMT = new DecimalFormat("#,##0.00");
  }

  boolean setText(String _t, boolean interact) {
    _t = _t.replace(' ', FMT.getDecimalFormatSymbols().getGroupingSeparator());
    boolean ok = super.setText(_t, interact);

    if (!ok) {
      return false;
    }
    ok = _lib.is_value(_t, FMT.getDecimalFormatSymbols().getDecimalSeparator(),
                       FMT.getDecimalFormatSymbols().getGroupingSeparator());
    if (!ok) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Valor estranho: " + _t + ".",
                                      "Erro", JOptionPane.WARNING_MESSAGE);
      }
      return ok;
    }
    v = new Double(_lib.round(v.doubleValue()));

    return ok;
  }

  // FILIPA
  boolean setString(String s) {
    if (s.length() == 0) {
      v = null;
      return true;
    }
    v = new Double(Double.parseDouble(s));
    //JOptionPane.showMessageDialog( null, "Recolhe: " + v.toString() );
    return true;
  }

  boolean acceptKey(char c) {
    if (Character.isDigit(c)) { return true; }
    if (c == KeyEvent.VK_COMMA) { return true; }
    if (c == KeyEvent.VK_PERIOD) { return true; }
    if (c == KeyEvent.VK_MINUS) { return true; }
    return false;
  }

  boolean isnull(String _t) {
    Number x = null;
    try {
      x = FMT.parse(_t);
    }
    catch (Exception p) {
      return false;
    }
    if (x.doubleValue() == 0) {
      return true;
    }
    return false;
  }

}

class CFType_Valor
    extends CFType_ValorS {
  CFType_Valor() {
    super();
  }

  boolean setText(String _t, boolean interact) {
    boolean ok = super.setText(_t, interact);

    if (ok && v != null && v.longValue() < 0) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Valor negativo.", "Erro",
                                      JOptionPane.WARNING_MESSAGE);
      }
      return false;
    }
    return ok;
  }

  boolean acceptKey(char c) {
    if (Character.isDigit(c)) {
      return true;
    }
    if (c == KeyEvent.VK_COMMA) {
      return true;
    }
    if (c == KeyEvent.VK_PERIOD) {
      return true;
    }
//    if (c == KeyEvent.VK_MINUS)return true;
    return false;
  }

  boolean isnull(String _t) {
    Number x = null;
    try {
      x = FMT.parse(_t);
    }
    catch (Exception p) {
      return false;
    }
    if (x.doubleValue() == 0) {
      return true;
    }
    return false;
  }

}

class CFType_ValorS0
    extends CFTypeNumber {
  CFType_ValorS0() {
    super();
    FMT = new DecimalFormat("#,##0.00");
  }

  boolean setText(String _t, boolean interact) {

    //JOptionPane.showMessageDialog(null, "setText ValorS0" );
    //System.out.println( "Valor s0");

    _t = _t.replace(' ', FMT.getDecimalFormatSymbols().getGroupingSeparator());
    boolean ok = super.setText(_t, interact);

    if (!ok) {
      return false;
    }
    ok = _lib.is_value(_t, FMT.getDecimalFormatSymbols().getDecimalSeparator(),
                       FMT.getDecimalFormatSymbols().getGroupingSeparator());
    if (!ok) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Valor estranho: " + _t + ".",
                                      "Erro", JOptionPane.WARNING_MESSAGE);
      }
      return ok;
    }
    v = new Double(_lib.round(v.doubleValue()));

    return ok;
  }

  boolean acceptKey(char c) {
    if (Character.isDigit(c)) {
      return true;
    }
    if (c == KeyEvent.VK_COMMA) {
      return true;
    }
    if (c == KeyEvent.VK_PERIOD) {
      return true;
    }
    if (c == KeyEvent.VK_MINUS) {
      return true;
    }
    return false;
  }

  boolean isnull(String _t) {
    Number x = null;
    try {
      x = FMT.parse(_t);
    }
    catch (Exception p) {
      return false;
    }
    //if ( x.doubleValue() == 0 ) return true;
    return false;
  }

  String getText() {
    if (v == null) {
      return "";
    }
    ;
    if (v.doubleValue() == 0) {
      return "0";
    }
    return super.getText();
  }

  // FILIPA
  boolean setString(String s) {
    if (s.length() == 0) {
      v = null;
      return true;
    }
    v = new Double(Double.parseDouble(s));
    //JOptionPane.showMessageDialog( null, "Recolhe: " + v.toString() );
    return true;
  }

  //FILIPA
  String getString() {
    if (v == null) {
      return "";
    }
    return _lib.to_string(v.doubleValue());
  }
}

class CFType_Valor0
    extends CFType_ValorS0 {
  CFType_Valor0() {
    super();
  }

  boolean setText(String _t, boolean interact) {

    //JOptionPane.showMessageDialog(null, "setText Valor0" );

    boolean ok = super.setText(_t, interact);

    if (ok && v != null && v.doubleValue() < 0) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Valor invlido (" + _t + ").\n"
                                      + "O valor no pode ser negativo!",
                                      "Erro",
                                      JOptionPane.ERROR_MESSAGE);
      }
      return false;
    }
    //v = new Double ( _lib.round(  v.doubleValue() ));

    return ok;
  }

  boolean acceptKey(char c) {
    if (Character.isDigit(c))
      return true;
    if (c == KeyEvent.VK_COMMA)
      return true;
    if (c == KeyEvent.VK_PERIOD)
      return true;
    if (c == KeyEvent.VK_MINUS)
      return true;
    return false;
  }

}

class CFType_Data
    extends CFType {
  Date d;
  static SimpleDateFormat FMT;
  CFType_Data() {
    super();
    FMT = new SimpleDateFormat("yyyy-MM-dd");
  }

  boolean setText(String _t, boolean interact) {

    _t = _t.replace(' ', '-');
    _t = _t.replace('/', '-');
    _t = _t.replace('.', '-');

    if (_lib.exact_match(_t, "#-#-####")) {
      _t = "0" + _t;
    }
    if (_lib.exact_match(_t, "#-##-####")) {
      _t = "0" + _t;
    }
    if (_lib.exact_match(_t, "##-#-####")) {
      _t = _t.substring(0, 3) + "0" + _t.substring(3, 9);
    }
    if (_lib.exact_match(_t, "##-##-####")) {
      _t = _t.substring(6, 10) + "-" + _t.substring(3, 5) + "-" +
          _t.substring(0, 2);
    }

    if (_t.length() >= 3 && _lib.exact_match(_t.substring(0, 3), "##-")) {
      _t = "20" + _t;
    }
    if (_t.length() == 8 && _lib.is_digitsOnly(_t)) {
      _t = _t.substring(0, 4) + "-" + _t.substring(4, 6) + "-" +
          _t.substring(6, 8);
      //JOptionPane.showMessageDialog(null, "data fica: " + _t);
    }
    try {
      d = FMT.parse(_t);
    }
    catch (Exception p) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Data invlida.", "Erro",
                                      JOptionPane.ERROR_MESSAGE);
      }
      return false;
    }

    boolean ok;
    /* ???
         boolean ok = super.setText ( _t);
         if ( !ok ) {
       JOptionPane.showMessageDialog(null, "Que problema ?", "Erro", JOptionPane.ERROR_MESSAGE);
       return false;
         }
     */

    ok = _lib.is_date(_t);
    if (!ok) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Data incorrecta.", "Erro",
                                      JOptionPane.ERROR_MESSAGE);
      }
      return ok;
    }
    return ok;
  }

  String getText() {
    if (d == null) {
      return "";
    }
    return FMT.format(d);
  }

  String getString() {
    return getText();
  }

  boolean setString(String _t) {
    if (_t.length() == 0) {
      d = null;
      return true;
    }
    boolean ok = true;
    try {
      d = FMT.parse(_t);
    }
    catch (Exception e) {
      ok = false;
    }
    ;
    return ok;
  }

  static Date parse_date(String s) {
    Date d = null;
    try {
      d = FMT.parse(s);
      //JOptionPane.showMessageDialog(null, "parse data: " + d.toString());
    }
    catch (Exception e) {}
    ;
    return d;
  }

  static String to_string(Date d) {
    String s = "";
    if (d == null) {
      return s;
    }
    return FMT.format(d);
  }

  boolean acceptKey(char c) {
    if (Character.isDigit(c)) {
      return true;
    }
    if (c == KeyEvent.VK_SLASH) {
      return true;
    }
    if (c == KeyEvent.VK_MINUS) {
      return true;
    }
    return false;
  }

}

class CFType_Email
    extends CFType {

  String v;

  CFType_Email() {
    super();
  }

  boolean setText(String _v, boolean interact) {
    v = _v;
    //public static boolean Email_ValOnline ( String _v) {

    if (_v.length() == 0) {
      return true;
    }
    String erro = "E-mail invlido.";

    //float n;
    int brancos_idx = _v.indexOf(" ");
    String[] n_arrobas = _v.split("@");
    int arroba_idx = _v.indexOf("@");
    int virgula_idx = _v.indexOf(",");
    int ponto_idx = _v.indexOf(".", arroba_idx);
    int tam = v.length();
    if (brancos_idx != -1 ||
    	arroba_idx == -1 ||
        virgula_idx != -1 ||
        (arroba_idx != -1 && (arroba_idx >= ponto_idx - 1)) ||
        tam - 1 == _v.lastIndexOf(".") || 
        tam - 1 == _v.lastIndexOf("@") ||
        n_arrobas.length!=2) {
      if (interact) {
        JOptionPane.showMessageDialog(null, erro, "Erro",
                                      JOptionPane.ERROR_MESSAGE);
      }
      return false;
    }
    return true;
  }

  boolean setString(String s) {
    v = s;
    return true;
  }

  String getText() {
    return v;
  }

  String getString() {
    return v;
  }

}

class CFType_Nif extends CFTypeNumber {
  CFType_Nif() {
    super();
    FMT = new DecimalFormat("#########");
  }

  boolean setText(String _t, boolean interact) {
    v = null;
    if (_t.length() == 0) {
      return true;
    }
    String erro = "NIF invlido.";
    boolean ok;
    String e = _t.substring(0, 1);

    /* tipo derivado NIF_T
         // NIF Temporrio.
         if (e.equals("T")) {
      if (_t.length() == 9) {
        return true;
      }
      else {
        JOptionPane.showMessageDialog(null, erro, "Erro",
                                      JOptionPane.ERROR_MESSAGE);
        return false;
      }
         }
     */

    ok = super.setText(_t, interact);
    if (!ok) {
      return ok;
    }

    if (_t.length() != 9) {
      ok = false;
    }
    if (!ok) {
      if (interact) {
        JOptionPane.showMessageDialog(null, erro, "Erro",
                                      JOptionPane.ERROR_MESSAGE);
      }
      return ok;
    }

    ok = _lib.is_digitsOnly(_t);
    if (!ok) {
      if (interact) {
        JOptionPane.showMessageDialog(null, erro, "Erro",
                                      JOptionPane.ERROR_MESSAGE);
      }
      return ok;
    }

    if (e.equals("T")) {
      return true;
    }

    String[] array = {
        "1", "2", "5", "6", "8", "9"};
    ok = false;
    for (int i = 0; i < array.length; i++) {
      if (e.equals(array[i])) {
        ok = true;
      }
    }
    if (!ok) {
      if (interact) {
        JOptionPane.showMessageDialog(null, erro, "Erro",
                                      JOptionPane.ERROR_MESSAGE);
      }
      return ok;
    }

    long cdg = 0;
    Character zero = new Character('0');
    Character ultimo;
    for (int i = 0; i < 8; i++) {
      e = _t.substring(i, i + 1);
      char[] d = e.toCharArray();
      Character a = new Character(d[0]);
      cdg = cdg + ( (int) a.charValue() - (int) zero.charValue()) * (i + 2);
    }
    cdg = cdg % 11;
    if (cdg == 10) {
      ultimo = zero;
      cdg = 0;
    }
    else {
      char[] asciiChar = { (char) ( (int) (zero.charValue() + cdg))};
      ultimo = new Character(asciiChar[0]);
    }
    if (!ultimo.toString().equals(_t.substring(8, 9))) {
      if (interact) {
        JOptionPane.showMessageDialog(null, erro, "Erro",
                                      JOptionPane.ERROR_MESSAGE);
      }
      return false;
    }
    return true;
  }
}

class CFType_CodPostal
    extends CFType {
  String v;

  boolean setText(String _t, boolean interact) {
    v = _t;
    if (v.length() == 0) {
      return true;
    }
    boolean ok = _lib.exact_match(_t, "####-###");
    if (ok){
    	if (Integer.parseInt(v.substring(0, 4))<1000)
    		ok = false;
    	if (Integer.parseInt(v.substring(5, 8))==0)
    		ok = false;
        if (!ok) {
            if (interact) {
              JOptionPane.showMessageDialog(null, "Cdigo Postal invlido.", "Erro",
                                            JOptionPane.ERROR_MESSAGE);
              return ok;
            }
        }
    }
    if (!ok) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Cdigo Postal incorrecto.\n"+
                                      "Por favor, introduza o Cdigo Postal no formato \"nnnn-nnn\".", "Erro",
                                      JOptionPane.ERROR_MESSAGE);
      }
    }
    return ok;
  }

  boolean setString(String s) {
    v = s;
    return true;
  }

  String getText() {
    return v;
  }

  String getString() {
    return v;
  }

  boolean acceptKey(char c) {
    if (Character.isDigit(c)) {
      return true;
    }
    if (c == KeyEvent.VK_MINUS) {
      return true;
    }
    return false;
  }

}

class CFType_AnoMes
    extends CFType {
  String v;

  boolean setText(String _t, boolean interact) {
    v = _t;
    if (v.length() == 0) {
      return true;
    }

    if (_lib.exact_match(_t, "##-####")) {
      String s = _t;
      _t = s.substring(3) + "-" + s.substring(0, 2);
      //JOptionPane.showMessageDialog(null, "corrige para: " + _t);
      v = _t;
    }

    boolean ok = _lib.exact_match(_t, "####-##");
    if (!ok) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Ano-Ms invlido.", "Erro",
                                      JOptionPane.ERROR_MESSAGE);
      }
      return ok;
    }

    int ano, mes;
    ano = Integer.parseInt(_t.substring(0, 4));
    mes = Integer.parseInt(_t.substring(5));
    if (mes > 12) {
      if (interact) {
        JOptionPane.showMessageDialog(null, "Ms invlido.", "Erro",
                                      JOptionPane.ERROR_MESSAGE);
      }
      return false;
    }
    return true;
  }

  boolean setString(String s) {
    v = s;
    return true;
  }

  String getText() {
    return v;
  }

  String getString() {
    return v;
  }

  static Date parse_as_date(String s) {
    //JOptionPane.showMessageDialog(null, "parse_as_date: " + s);
    if (s == null) {
      return null;
    }
    if (s.length() != 7) {
      return null;
    }
    int ano, mes;
    ano = Integer.parseInt(s.substring(0, 4));
    mes = Integer.parseInt(s.substring(5));
    Date d = new Date(ano - 1900, mes - 1, 1);
    //JOptionPane.showMessageDialog(null, "parse data as: " + d.toString());
    return d;
  }

  boolean acceptKey(char c) {
    if (Character.isDigit(c)) {
      return true;
    }
    //if (c == KeyEvent.VK_SLASH)return true;
    if (c == KeyEvent.VK_MINUS) {
      return true;
    }
    return false;
  }

}

//--------------------------------------------------------------------
//
//--------------------------------------------------------------------
class DefaultTableCellRenderer_RIGTH
    extends DefaultTableCellRenderer {
  DefaultTableCellRenderer_RIGTH() {
    super();
    setHorizontalAlignment(SwingConstants.RIGHT);
    //this.setForeground(Color.BLACK);
    //this.setOpaque(true);
  }
}

class DefaultTableCellRenderer_CENTER
    extends DefaultTableCellRenderer {
  DefaultTableCellRenderer_CENTER() {
    super();
    setHorizontalAlignment(SwingConstants.CENTER);
  }
}

//------------------------------------------------------------------------------
// _lib : funoes de base
//------------------------------------------------------------------------------

class _lib {
  static boolean is_digitsOnly(String s) {
    //JOptionPane.showMessageDialog(null, "isDigitsOnly <" + s + ">");
    for (int i = 0; i < s.length(); i++) {
      if (!Character.isDigit(s.charAt(i))) {
        return false;
      }
    }
    return true;
  }

  static boolean is_number(String s, char g_sep) {
    //JOptionPane.showMessageDialog(null, "isNumber <" + s + ">");
    int cg = 0;
    for (int i = s.length() - 1; i >= 0; i--) {
      if (s.charAt(i) == '-' && i == 0) {
        continue;
      }
      cg = cg + 1;
      if (!Character.isDigit(s.charAt(i))) {
        if (cg != 4) {
          return false;
        }
        if (s.charAt(i) != g_sep) {
          return false;
        }
        cg = 0;
      }
      else if (cg == 4) {
        cg = 0;
      }
    }
    return true;
  }

  static boolean is_perc(String s, char d_sep) {
    int n = s.indexOf(d_sep);
    if (n >= 0) {
      return is_digitsOnly(s.substring(0, n)) &&
          is_digitsOnly(s.substring(n + 1, s.length()));
    }
    return is_digitsOnly(s);
  }

  static boolean is_value(String s, char d_sep, char g_sep) {

    if (s.startsWith("-")) {
      s = s.substring(1);
    }
    int n = s.indexOf(d_sep);
    if (n >= 0) {
      return is_number(s.substring(0, n), g_sep) &&
          is_digitsOnly(s.substring(n + 1, s.length()));
    }
    return is_number(s, g_sep);
  }

  static boolean is_date(String s) {
    int n = s.indexOf('-');
    if (! (n > 0)) {
      return false;
    }
    if (!is_digitsOnly(s.substring(0, n))) {
      return false;
    }
    int ano = Integer.parseInt(s.substring(0, n));
    if (ano < 1800) {
      return false;
    }

    int n1 = s.indexOf('-', n + 1);
    if (! (n1 > 0)) {
      return false;
    }
    if (!is_digitsOnly(s.substring(n + 1, n1))) {
      return false;
    }
    int mes = Integer.parseInt(s.substring(n + 1, n1));
    if (mes < 1 || mes > 12) {
      return false;
    }

    if (! (s.length() > n1)) {
      return false;
    }
    if (!is_digitsOnly(s.substring(n1 + 1, s.length()))) {
      return false;
    }
    int dia = Integer.parseInt(s.substring(n1 + 1, s.length()));
    if (dia < 1 || dia > 31) {
      return false;
    }
    if (dia == 31 && (mes == 2 || mes == 4 || mes == 6 || mes == 11)) {
      return false;
    }
    if (mes == 2 && dia > 29) {
      return false;
    }
    if (mes == 2 && dia == 29) {
      return ano % 4 == 0;
    }
    return true;
  }

  static boolean exact_match(String v, String p) {
    //JOptionPane.showMessageDialog( null, "Match <" + v + "> e <" + p + ">");
    if (v.length() != p.length()) {
      return false;
    }
    for (int i = 0; i < v.length(); i++) {
      if (p.charAt(i) == '#') {
        if (!Character.isDigit(v.charAt(i))) {
          return false;
        }
      }
      else if (p.charAt(i) != v.charAt(i)) {
        return false;
      }
    }
    return true;
  }

  // em teste !
  static double get_double(String s) {
    Number v = null;
    try {
      v = CFLib.VLD_VALOR_S.FMT.parse(s);
    }
    catch (Exception e) {}
    ;
    if (v == null) {
      return 0;
    }
    return v.doubleValue();
  }

  static String xml_encode(String tag, String v) {
    String xml = null;
    v = v.replaceAll("&", "&amp;");
    v = v.replaceAll("<", "&lt;");
    xml = "<" + tag + ">";
    xml += v;
    xml += "</" + tag + ">\n";
    return xml;
  }

  static String to_string ( double v ) {
    v = _lib.round(v);
    String s = Double.toString(v);
    if ( v == (int) v ) s = Integer.toString( (int) v);
    if (v != (long) v || s.indexOf('E') > 0 || s.indexOf('e') > 0) {
      DecimalFormat f = new DecimalFormat("######################0.##");
      s = f.format(_lib.round(v));
      s = s.replace(',', '.');
    }
    return s;
  }

  static double round( double x ) {
    long l;
    if (x >= 0)
      l = (long) ( (x + 0.005) * 100);
    else
      l = (long) ( (x - 0.005) * 100);
    if ( ("" + x).endsWith(".005") && ("" + l).endsWith("0")) {
      if (x > 0) l = l + 1;
      else l = l - 1;
    }
    return (double) l / 100;
  }

  static double to_double(String s) {
    double x = 0;
    if (s.length() == 0) {
      return x;
    }
    x = Double.parseDouble(s);
    return x;
  }

  static String to_format(double d) {
    return CFLib.VLD_VALOR.FMT.format(d);
  }

  static String get_pagina(String s) {
    int n = s.indexOf("-");
    String pagina = s.substring(0, n - 1);
    return pagina;
  }

  static String get_titulo(String s) {
    int n = s.indexOf("-");
    String titulo = s.substring(n + 1, s.length());
    return titulo;
  }
  
  static int numUnNull(String t){
	  if (t == null) return 0;
	  if (t.length()==0) return 0;
	  return Integer.parseInt(t);
  }


}

//---------------------------------------------------
//
//---------------------------------------------------

class StdCellEditor
    extends DefaultCellEditor {

  StdCellEditor(JTextField jc) {
    super(jc);
    setClickCountToStart(1);
  }

  CHTabela handler;
  int eRow, eCol;

  void force_stopCellEditing() {
    super.stopCellEditing();
  }

  public boolean stopCellEditing() {
    //JOptionPane.showMessageDialog(null, "stop cell editing");
    if (handler != null) {
      boolean ok = handler.valOnline(this.getCellEditorValue(), eRow, eCol);
      //if ( !ok) { editing = true; return false;}
      if (!ok) {
        return false;
      }
    }
    return super.stopCellEditing();
  }

  public Component getTableCellEditorComponent(JTable table,
                                               Object value,
                                               boolean isSelected,
                                               int row,
                                               int column) {
    handler = (CHTabela) table.getModel();
    eRow = row;
    eCol = column;

    return super.getTableCellEditorComponent(table, value, isSelected, row,
                                             column);

    /*
         Component j = super.getTableCellEditorComponent( table, value, isSelected, row, column);
         j.addFocusListener(new StdCellEditor_focusAdapter(this));
         editing = true;
         return j;
     */
  }

  /*
     void _focusLost(FocusEvent e) {
    if ( editing) {
      editing = false; handler.j.getCellEditor().cancelCellEditing();
      handler.j.repaint();
    }
     }
   */
}

/*
 class StdCellEditor_focusAdapter extends java.awt.event.FocusAdapter {
   StdCellEditor adaptee;

   StdCellEditor_focusAdapter(StdCellEditor adaptee) {
     this.adaptee = adaptee;
   }
   public void focusLost(FocusEvent e) {
     adaptee._focusLost(e);
   }
 }

*/
class FreguesiaCellEditor
    extends DefaultCellEditor {

  FreguesiaCellEditor(JComboBox jc) {
    super(jc);
    setClickCountToStart(1);
  }

  void force_stopCellEditing() {
    super.stopCellEditing();
  }

  public Component getTableCellEditorComponent(JTable table,
                                               Object value,
                                               boolean isSelected,
                                               int row,
                                               int column) {

    Component c = super.getTableCellEditorComponent(table, value, isSelected,
        row, column);

    if (table.getName().startsWith("PromLocal")){
    	CBTabela_PromLocal pl = CBData.PromLocal;
    	String tab_name = table.getName();
    	tab_name = tab_name.substring( tab_name.lastIndexOf("_")+1, tab_name.length());
        //System.out.print(tab_name+"-----\n");
        if (!tab_name.equals("0"))
        	pl = ((CBTabela_PromLocal) CBData.ListaCoop.Lista_PromLocal.elementAt(Integer.parseInt(tab_name)-1));
    	pl._filter_populate_freguesias((SteppedComboBox) c, row);
    }
    if (table.getName().startsWith("Milestones")){
    	CBTabela_ActResultados miles = null;
    	String tab_name = table.getName();
    	tab_name = tab_name.substring( tab_name.lastIndexOf("_")+1, tab_name.length());
        //System.out.print(tab_name+"-----\n");
        if (!tab_name.equals("0"))
        	miles = ((CBTabela_ActResultados) CBData.ActLista.Lista_Resultados.elementAt(Integer.parseInt(tab_name)-1));
        miles._filter_populate_freguesias((SteppedComboBox) c, row);
    }
    if (table.getName().equals("PME_Tabela"))
        CBData.PME._filter_populate_freguesias((SteppedComboBox) c, row);
    if (table.getName().equals("QInv_Tabela"))
        CBData.QInv._filter_populate_estabs((SteppedComboBox) c, row);
    if (table.getName().equals("QuadrosTecn_Tabela"))
        CBData.QuadrosTecn._filter_populate_estabs((SteppedComboBox) c, row);
    return c;
  }

}

//-----------------------------------------------------------------------

// TextFieldKeyListener

class TextFieldKeyListener
    extends java.awt.event.KeyAdapter {
  JFormattedTextField j;

  TextFieldKeyListener(JFormattedTextField _j) {
    this.j = _j;
  }

  public void keyTyped(KeyEvent e) {

    CHCampo_Text h = (CHCampo_Text) j.getClientProperty("handler");
    CFType vld = h.vld;

    char c = e.getKeyChar();
    if (c == KeyEvent.VK_BACK_SPACE) {
      return;
    }
    if (c == KeyEvent.VK_DELETE) {
      return;
    }
    if (!vld.acceptKey(c)) {
      e.consume();
    }
  }
}

// TypeKeyListener (cell editor)

class TypeKeyListener
    extends java.awt.event.KeyAdapter {
  CFType t;

  TypeKeyListener(CFType _t) {
    this.t = _t;
  }

  public void keyTyped(KeyEvent e) {
    if (t == null) {
      return;
    }
    char c = e.getKeyChar();
    if (c == KeyEvent.VK_BACK_SPACE) {
      return;
    }
    if (c == KeyEvent.VK_DELETE) {
      return;
    }
    if (!t.acceptKey(c)) {
      e.consume();
    }
  }
}

// TableKeyListener

class TableKeyListener
    extends java.awt.event.KeyAdapter {
  CBTabela t;

  TableKeyListener(CBTabela _t) {
    this.t = _t;
  }

  public void keyTyped(KeyEvent e) {
    JTable j = t.handler.j;
    if (!j.isEditing()) {
      return;
    }
    int col = j.getEditingColumn();

    col = t.handler.cdx[col];
    CFType vld = t.cols[col].vld;

    // FACADA - REVER
    if (t.handler instanceof CHTabQuadro) {
      int row = j.getEditingRow();
      if ( ( (CHTabQuadro) t.handler).row_vld[row] != null) {
        vld = ( (CHTabQuadro) t.handler).row_vld[row];
      }
    }
    if (vld == null) {
      return;
    }

    char c = e.getKeyChar();
    if (c == KeyEvent.VK_BACK_SPACE) {
      return;
    }
    if (c == KeyEvent.VK_DELETE) {
      return;
    }
    if (!vld.acceptKey(c)) {
      e.consume();
    }
  }
}
