package fme;

import java.util.*;
import javax.swing.table.*;
import java.util.Vector;
import javax.swing.*;

import java.awt.*;


//----------------------------------------------------------------------------
// CHCampo
//----------------------------------------------------------------------------

class CHCampo {
  public String tag;
  String v;
  CBRegisto dh;
  boolean xml_enabled;

  public CHCampo( ) {
    dh = null;
    xml_enabled = true;
    v = "";
    tag = "";
  }

  public CHCampo( String _tag ) {
    dh = null;
    xml_enabled = true;
    v = "";
    tag = _tag;
  }

  void extract() {
  }

  void clear() {
    v = "";
  }

  void setStringValue( String _v) {
     //JOptionPane.showMessageDialog(null, "Campo  " + tag + " recebe " + _v );
     v = _v;
  }

  String getStringValue() {
    return v;
  }

  boolean vldOnline() {
    return true;
  }

  void show() {
  }

  boolean isEmpty() {
    if ( v == null ) return true;
    return v.trim().length() == 0;
  }

  double valueAsDouble() {
    return 0;
  }

  void set_focus() {
    //JOptionPane.showMessageDialog(null, "set focus def...");
  }

  void setValue ( Object v ) {
  }

  void cancel_editing () {
  }

}

//------------------------------------------------------------------------------
// CHCampo Text
//------------------------------------------------------------------------------

class CHCampo_Text extends CHCampo {
  JTextField jcomp;
  CFType vld;
  String undo_v;

  public CHCampo_Text( String _tag , JTextField _jcomp, CFType _vld ) {
    tag = _tag;
    v = "";
    setComponent ( _jcomp);
    vld = _vld;
    dh = null;
  }

  public CHCampo_Text( String _tag , JTextField _jcomp, CFType _vld, CBRegisto _dh ) {
    tag = _tag;
    v = "";
    setComponent ( _jcomp);
    vld = _vld;
    dh = _dh;
  }


  public void setComponent ( JTextField _jcomp) {
    jcomp = _jcomp;
    jcomp.setInputVerifier( CFLib.CHInputVerifier  );
    jcomp.putClientProperty("handler", this);
  }

  void extract() {
    if ( jcomp.getInputVerifier() != null ) return;
    v = jcomp.getText();
  }

  void clear() {
    v = "";
    jcomp.setText(v);

    // chamar updHandler...

  }

  // path "off line"
  void setStringValue(String _v) {
    //JOptionPane.showMessageDialog(null, "setStringValue:  " + tag + " recebe " + _v );
    v = _v;
    if ( v == null || _v.equals("0.0") ) v = "";
    String t = v;
    if ( vld != null && _v.length() > 0 ) {
      vld.setString(_v);
      t = vld.getText();
      //FILIPA
      v = vld.getString();
    }
    jcomp.setText(t);
    if ( dh != null ) dh.on_update( tag );
  }

  boolean vldOnline() {
    if ( CHCampo_InputVerifier.editing == null ) undo_v = v;
    String b = v;

    //JOptionPane.showMessageDialog(null, "Validar---");

    // extract
    if (jcomp instanceof JFormattedTextField) {
      try { ((JFormattedTextField)jcomp).commitEdit(); } catch (Exception e) {}
    }
    v = jcomp.getText();

    if ( v.length() == 0 ) {
      if ( jcomp instanceof JFormattedTextField ) {
        ((JFormattedTextField) jcomp).setValue(null);
        if ( dh != null ) dh.on_update( tag );
        if ( ! b.equals( v ))  CBData.setDirty(); //JOptionPane.showMessageDialog(null, "dirty...");
        return true;
      }
    }
    //end extract

    if ( vld != null && vld.isnull(v) ) {
      jcomp.setText("");
      v = "";
      if ( dh != null ) dh.on_update( tag  );
      if ( ! b.equals( jcomp.getText())) CBData.setDirty(); // JOptionPane.showMessageDialog(null, "dirty...");
      return true;
    }

    if ( vld == null ) {
      //JOptionPane.showMessageDialog(null, "No carece validao---");
      if ( dh != null ) dh.on_update( tag  );
      if ( ! b.equals( v)) CBData.setDirty(); //JOptionPane.showMessageDialog(null, "dirty...");
      return true;
    }

    //JOptionPane.showMessageDialog(null, "Pedir validao de --- " + v);
    boolean ok = vld.setText(v);
    if ( ok ) {
      v = vld.getString();
      //JOptionPane.showMessageDialog(null, "Validao passou v a --- " + v);
      if (jcomp instanceof JFormattedTextField) {
        //JOptionPane.showMessageDialog(null, "Formatado d --- " + vld.getText());
        ( (JFormattedTextField) jcomp).setText(vld.getText());
      }
    }
    if ( dh != null && ok ) dh.on_update( tag  );
    //if ( ok )  JOptionPane.showMessageDialog(null, "passou de " + b + " para " + v);
    if ( ok && ! b.equals( v)) CBData.setDirty(); //JOptionPane.showMessageDialog(null, "dirty...");
    return ok;
  }

  double valueAsDouble ( ) {
    if ( v.length() == 0 ) return 0;
    //return Double.parseDouble( v ); 
    return _lib.to_double(v); // Aores
  }

  void set_focus() {
    //JOptionPane.showMessageDialog(null, "campo text set focus...");
    jcomp.requestFocus();
  }

  void setValue ( Object _v ) {
    v = _v.toString();
    String s = v;
    if ( vld != null ) {
      vld.setValue(_v);
      v = vld.getString();
      s = vld.getText();
    }
    jcomp.setText(s);
  }

  void cancel_editing () {
    //JOptionPane.showMessageDialog(null, "repor " + tag + " : " + undo_v);
    this.setStringValue( undo_v);
    CHCampo_InputVerifier.editing = null;
  }

}

//------------------------------------------------------------------------------
// CHCampo TextArea
//------------------------------------------------------------------------------

class CHCampo_TextArea extends CHCampo {
  JTextArea jcomp;
  //CFType vld;

  public CHCampo_TextArea( String _tag , JTextArea _jcomp, CBRegisto _dh ) {
    tag = _tag;
    v = "";
    //jcomp = _jcomp;
    setComponent ( _jcomp);
    //vld = _vld;
    //updHandler = null;
    dh = _dh;
  }

  public void setComponent ( JTextArea _jcomp) {
    jcomp = _jcomp;
    jcomp.setInputVerifier( CFLib.CHInputVerifier  );
    jcomp.putClientProperty("handler", this);
  }

  void extract() {
    v = jcomp.getText();
  }

  boolean vldOnline() {

    String b = v;
    extract();
    if ( ! b.equals(v) ) CBData.setDirty();
    if ( dh != null ) dh.on_update( tag  );
    return true;
  }

  void clear() {
    v = "";
    jcomp.setText(v);
  }

  void setStringValue(String _v) {
    //JOptionPane.showMessageDialog(null, "Campo Texto  " + name + " recebe " + _v );
    v = _v;
    String t = v;
    jcomp.setText(t);
  }
}



//------------------------------------------------------------------------------
// CHCampo Option (radios) : escolher 1/N hipteses
//------------------------------------------------------------------------------

class CHCampo_Opt extends CHCampo {
  String [] opts ;
  Vector jcomps = new Vector();
  JCheckBox dummy;

  public CHCampo_Opt(String _tag) {
	    tag = _tag;
	    v = "";
	    opts = null;
	  }
  public CHCampo_Opt(String _tag, CBRegisto _dh) {
	  tag = _tag;
	  v = "";
	  opts = null;
	  dh = _dh;
  }

  public CHCampo_Opt(String _tag, String [] _opts) {
	  tag = _tag;
	  v = "";
	  opts = _opts;
  }
  public CHCampo_Opt(String _tag, String [] _opts, CBRegisto _dh) {
	  tag = _tag;
	  v = "";
	  opts = _opts;
	  dh = _dh;
  }

  public void setOptions(String opt1, String opt2) {
    opts = new String[2];
    opts[0] = opt1;
    opts[1] = opt2;
  }

  public void addComponent(JCheckBox _jcomp) {
    jcomps.addElement(_jcomp);
    _jcomp.setInputVerifier( CFLib.CHInputVerifier  );
    _jcomp.putClientProperty("handler", this);
  }

  public void addDummy(JCheckBox _jcomp) {
      dummy = _jcomp;
  }

  void extract() {
    v = "";
    int i;
    for(i = 0; i < jcomps.size(); i ++) {
        if(((JCheckBox) jcomps.elementAt(i)).isSelected())
            v = opts[i];
    }
  }

  void clear() {
    v = "";
    int i;
    for(i = 0; i < jcomps.size(); i ++) {
      if(((JCheckBox) jcomps.elementAt(i)).isSelected())
      {
        ( (JCheckBox) jcomps.elementAt(i)).setSelected(false);
        //JOptionPane.showMessageDialog(null, "Limpou check-box " + i);
        dummy.setSelected(true);
      }
    }
  }

  void setStringValue(String _v) {
    //JOptionPane.showMessageDialog(null, "Campo Opt  recebe " + _v );
    v = _v;
    int i;
    for(i = 0; i < jcomps.size(); i ++) {
        boolean c;
        c = opts[i].equals(v);
        ((JCheckBox) jcomps.elementAt(i)).setSelected(c);
    }
  }

  String getStringValue() {
    extract();
    return v;
  }

  boolean vldOnline() {
    String b = v;
    extract();
    if ( ! b.equals(v) ) CBData.setDirty(); //JOptionPane.showMessageDialog(null, "dirty...");
    if ( dh != null ) dh.on_update(tag);
    return true;
  }

}


//------------------------------------------------------------------------------
// CHCampo ComboBox
//------------------------------------------------------------------------------

class CHCampo_Combo extends CHCampo {
  String tabname;
  JComboBox jcomp;
  int v_idx;
  String v_text;

  public CHCampo_Combo(String _tag, String _tabname, JComboBox _jcomp) {
    tag = _tag;
    tabname = _tabname;
    jcomp = _jcomp;
    v = "";

    CTabela t = CTabelas.getTabByName(tabname);
    t._populateComboBox(jcomp);
//    jcomp.setMaximumRowCount(3);
  //  jcomp.setFont(fmeFrame.letra);

    // funciona !?
    //jcomp.putClientProperty("handler", this);
    //jcomp.setInputVerifier( CFLib.CHInputVerifier  );

    dh = null;
  }

  public CHCampo_Combo(String _tag, String _tabname, JComboBox _jcomp, CBRegisto _dh) {
    tag = _tag;
    tabname = _tabname;
    jcomp = _jcomp;
    v = "";
//JOptionPane.showMessageDialog(null, "campo = " + _tag);

    CTabela t = CTabelas.getTabByName(tabname);
    t._populateComboBox(jcomp);
    //jcomp.setFont(fmeFrame.letra);

    // NO FUNCIONA !!!???
    jcomp.putClientProperty("handler", this);
    jcomp.setInputVerifier( CFLib.CHInputVerifier  );
    //jcomp.setMaximumRowCount(3);

    dh = _dh;
  }


  /*
  public void setComponent ( JComboBox _jcomp) {
    jcomp = _jcomp;
  }
  */

  void extract() {
    v_idx = jcomp.getSelectedIndex();
    v_text = (String) jcomp.getSelectedItem();
    v = "";
    if( v_idx > 0 ){
     // JOptionPane.showMessageDialog(null, "v_text = " + v_text + "(" + v_idx + ") --- " + tabname);
      v = CTabelas.getTabByName(tabname).getCodeFromIndex(v_idx);
    }
  }

  /*
  // REVER !!!
  void extract_nutes() {
    v_idx = jcomp.getSelectedIndex ();
    v_text = (String) jcomp.getSelectedItem();
    v = "";
    if ( v_idx > 0 )
       v = CTabelas.getTabByName(tabname).getNutesFromIndex(v_idx);
  }
  */

  void clear() {
    if ( jcomp.getItemCount() > 0 )
      jcomp.setSelectedIndex(0);
    v = "";
  }

  // set programtico (xml)
  void setStringValue(String _v) {
     v = _v;
     if ( v.length() > 0 ) {
       v_idx = CTabelas.getTabByName(tabname).getIndexFromCode(v) + 1;
       jcomp.setSelectedIndex(v_idx);
     }
     //JOptionPane.showMessageDialog( null, "set: " + tabname + ", " + _v + " to: " + v_idx);
     // vai a valOnline via ActionPerformed !!! PODE-SE EVITAR ?
     //if ( dh != null ) dh.on_update(tag);
  }

  // set interactivo
  boolean vldOnline() {
    //JOptionPane.showMessageDialog(null, "validar isto...");
    //if ( updHandler != null ) updHandler.upd( "upd-" + tag  );
    String b = v;
    this.extract();
    if ( ! b.equals(v)) CBData.setDirty(); // JOptionPane.showMessageDialog(null, "dirty...");
    if ( dh != null ) dh.on_update ( tag );
    return true;
  }

}

//------------------------------------------------------------------------------
// CHTabelxmla
//------------------------------------------------------------------------------

class CHTabela extends AbstractTableModel {

  JTable j;
  CBTabela d;

  int width;
  //int[] col_width;
  //CFType[] vld;
  //String[] col_name;
  int cdx[];
  //boolean[] editable;

  CHTabela() {
  }

  void setup ( JTable _j, CBTabela _d ) {
    this.d = _d;
    this.j = _j;
    j.setModel(this);
    j.getTableHeader().setResizingAllowed(false);   // no deixa alargar as colunas
    j.getTableHeader().setReorderingAllowed(false); // no deixa trocar as colunas
  //  j.getTableHeader().setPreferredSize(new Dimension(500,22));
    // TESTE

/*
    for ( int i = 0; i < _j.getColumnModel().getColumnCount(); i++ ) {
      TableColumn c = _j.getColumnModel().getColumn(i);
      c.setHeaderRenderer( new StdTableHeaderRenderer ());
    }*/

    MultiLineHeaderRenderer renderer = new MultiLineHeaderRenderer();
/*    Enumeration enum = j.getColumnModel().getColumns();
    while (enum.hasMoreElements()) {
      ( (TableColumn) enum.nextElement()).setHeaderRenderer(renderer);
    }
*/
  }

  void set_col ( int nCol, double _pw, String _align ) {
    nCol = d.cols[nCol].t_col;
    TableColumn c;
    c = j.getColumnModel().getColumn(nCol);
    c.setMaxWidth( (int)( _pw * width) );
    c.setMinWidth( (int)( _pw * width));
    if ( _align != null && _align.equals("R") ) j.getColumnModel().getColumn(nCol).setCellRenderer(CFLib.TCRenderer_Rigth);
    if ( _align != null && _align.equals("C") ) j.getColumnModel().getColumn(nCol).setCellRenderer(CFLib.TCRenderer_Center);
  }

  SteppedComboBox set_col_comboS ( int nCol, double _pw, String _align, CTabela _tab, int _col_tab, int _cw ) {
    set_col ( nCol, _pw, _align );
    nCol = d.cols[nCol].t_col;
    SteppedComboBox jComboBox = new SteppedComboBox();
   // jComboBox.setFont(fmeFrame.letra);
    if ( _tab != null ) _tab._populateComboBox(jComboBox, _col_tab);
    jComboBox.setPopupWidth( _cw );
    jComboBox.setBorder(BorderFactory.createLineBorder(Color.black));
    j.getColumnModel().getColumn(nCol).setCellEditor( new DefaultCellEditor(jComboBox));
    return jComboBox;
  }

  SteppedComboBox set_col_comboL ( int nCol, double _pw, String _align, String[] list, int _col_tab, int _cw ) {
    set_col ( nCol, _pw, _align );
    nCol = d.cols[nCol].t_col;
    SteppedComboBox jComboBox = new SteppedComboBox(list);
    // jComboBox.setFont(fmeFrame.letra);
    //if ( _tab != null ) _tab._populateComboBox(jComboBox, _col_tab);
    jComboBox.setPopupWidth( _cw );
    jComboBox.setBorder(BorderFactory.createLineBorder(Color.black));
    j.getColumnModel().getColumn(nCol).setCellEditor( new DefaultCellEditor(jComboBox));
    return jComboBox;
  }



  JComboBox set_col_combo ( int nCol, double _pw, String _align, CTabela _tab, int _col_tab ) {
    set_col ( nCol, _pw, _align );
    nCol = d.cols[nCol].t_col;
    JComboBox jComboBox = new JComboBox();
//    jComboBox.setFont(fmeFrame.letra);
    jComboBox.setBorder(BorderFactory.createLineBorder(Color.black));
    if ( _tab != null ) _tab._populateComboBox(jComboBox, _col_tab);
    j.getColumnModel().getColumn(nCol).setCellEditor( new DefaultCellEditor(jComboBox));
    return jComboBox;
  }

  SteppedComboBox set_col_comboD ( int nCol, double _pw, String _align, CTabela _tab, int _col_tab, int _cw ) {
    set_col ( nCol, _pw, _align );
    nCol = d.cols[nCol].t_col;
    SteppedComboBox jComboBox = new SteppedComboBox();
    jComboBox.setRenderer( new DesignCellRenderer(_tab));
    
    jComboBox.setName("cbo-estabs");
    
    if ( _tab != null ) _tab._populateComboBox(jComboBox, _col_tab);
    jComboBox.setPopupWidth( _cw );
    jComboBox.setBorder(BorderFactory.createLineBorder(Color.black));
    j.getColumnModel().getColumn(nCol).setCellEditor( new DefaultCellEditor(jComboBox));
    return jComboBox;
  }

  SteppedComboBox set_col_comboF ( int nCol, double _pw, String _align, CTabela _tab, int _col_tab, int _cw ) {
	  set_col ( nCol, _pw, _align );
	  nCol = d.cols[nCol].t_col;
	  SteppedComboBox jComboBox = new SteppedComboBox();
	  // jComboBox.setFont(fmeFrame.letra);
	  if ( _tab != null ) _tab._populateComboBox(jComboBox, _col_tab);
	  jComboBox.setPopupWidth( _cw );
	  jComboBox.setBorder(BorderFactory.createLineBorder(Color.black));
	  j.getColumnModel().getColumn(nCol).setCellEditor( new FreguesiaCellEditor(jComboBox));
	  return jComboBox;
  }

  SteppedComboBox set_col_comboFD ( int nCol, double _pw, String _align, CTabela _tab, int _col_tab, int _cw ) {
	  set_col ( nCol, _pw, _align );
	  nCol = d.cols[nCol].t_col;
	  SteppedComboBox jComboBox = new SteppedComboBox();
	  jComboBox.setRenderer( new DesignCellRenderer(_tab));
	  // jComboBox.setFont(fmeFrame.letra);
	  if ( _tab != null ) _tab._populateComboBox(jComboBox, _col_tab);
	  jComboBox.setPopupWidth( _cw );
	  jComboBox.setBorder(BorderFactory.createLineBorder(Color.black));
	  
	  //#35 POR AQUI ALTERA A TABELA...
	  j.getColumnModel().getColumn(nCol).setCellEditor( new FreguesiaCellEditor(jComboBox));
	  return jComboBox;
  }

  JTextField set_col_text ( int nCol, double _pw, String _align ) {
    set_col ( nCol, _pw, _align );

    JTextField jText = new JTextField();

    //TESTE !!!
    jText.addKeyListener(new  TypeKeyListener( d.cols[nCol].vld ));
    jText.setBorder(BorderFactory.createLineBorder(Color.black));

    nCol = d.cols[nCol].t_col;
    if ( _align != null && _align.equals("R")) jText.setHorizontalAlignment(SwingConstants.RIGHT);
    j.getColumnModel().getColumn(nCol).setCellEditor(new StdCellEditor(jText));
    return jText;
  }

  void set_col_check ( int nCol, double _pw  ) {
    set_col ( nCol, _pw, null );
    nCol = d.cols[nCol].t_col;
    return;
  }

  public Object getValueAt(int i, int j) {
    j = cdx[j];
    String s = ((String[]) d.dados.elementAt(i))[j];
    if (d.cols[j].vld != null) {
      d.cols[j].vld.setString(s);
      s = d.cols[j].vld.getText();
    }
    if ( d.cols[j].is_check ) {
      //JOptionPane.showMessageDialog(null, "valor " + i + "," + j +" check");
      //return new Boolean(false);
      if ( s.equals("1") ) return Boolean.TRUE; //new Boolean(true);
      return Boolean.FALSE; //new Boolean(false);
    }
    return s;
  }

  public int getRowCount() {
    return d.dados.size();
  }

  public int getColumnCount() {
    return cdx.length;
  }

  public String getColumnName(int j) {
    j = cdx[j];
    //JOptionPane.showMessageDialog(null, "Coluna: " + j + ":" + d.cols[j].col_name);
    return d.cols[j].col_name;
  }

  public Class getColumnClass( int i) {
    i = cdx[i];
    Boolean b= new Boolean(true);
    String s = "";
    if ( d.cols[i].is_check ) {
      //JOptionPane.showMessageDialog(null, "tipo coluna " + i + " check");
      return b.getClass();
    }
    //return s.getClass();
    return super.getColumnClass(i);
  }

  public boolean isCellEditable(int i, int j) {
    j = cdx[j];
    //int idx = cdx[j];
    return d.cols[j].editable;
  }

  public void setValueAt(Object v, int i, int j) {

    //JOptionPane.showMessageDialog(null, "setValueAt - tabela");

    j = cdx[j];

    // ??? PRECISA ???
    if ( i+1 > d.dados.size() ) return;

    if ( d.cols[j].is_check ) {
      //JOptionPane.showMessageDialog(null, "valor: " + v.toString() + " class " + v.getClass().getName());
      //if ( ((Boolean) v).booleanValue() == true )
      if ( v == null )
        ( (String[]) d.dados.elementAt(i))[j] = "";
      else if ( v.toString().equals("true" ) )
        ( (String[]) d.dados.elementAt(i))[j] = "1";
      else
        ( (String[]) d.dados.elementAt(i))[j] = "0";
      return;
    }

    CFType vld = d.cols[j].vld;
    String a_value = ((String[]) d.dados.elementAt(i))[j];
    String s = (String) v;

    boolean ok = true;
    if ( s == null ) s = "";
    if (s.length() == 0) {
      ( (String[]) d.dados.elementAt(i))[j] = s;
      //return;
    }
    else if ( vld != null && vld.isnull(s) ) {
      ( (String[]) d.dados.elementAt(i))[j] = "";
    }
    else if (vld != null) {
      ok = vld.setText(s, false);
      //JOptionPane.showMessageDialog(null, "Validar..." + s);
      if ( ok )
        ( (String[]) d.dados.elementAt(i))[j] = vld.getString();
      //return;
    }
    else ( (String[]) d.dados.elementAt(i))[j] = s;

    //
    CBData.setDirty();

    //JOptionPane.showMessageDialog(null, "set value at");
    d.on_update( d.cols[j].col_tag, i, s );
    this.j.repaint();

  }

  public boolean valOnline (Object v, int i, int j) {
    j = cdx[j];
    CFType vld = d.cols[j].vld;
    String s = (String) v;

    //JOptionPane.showMessageDialog(null, "Validar: " + s );

    boolean ok = true;
    if (s.length() == 0) {
      return true;
    }
    else if (vld != null) {
      //JOptionPane.showMessageDialog(null, "ponto chave ?");
      ok = vld.setText(s);
      return ok;
    }
    return true;
  }

  void repaint_col_names() {
    for ( int i = 0; i < cdx.length; i ++ ) {
      int c = cdx[i];
      String s = d.cols[c].col_name;
      j.getTableHeader().getColumnModel().getColumn(i).setHeaderValue(s);
    }
  }

  // !!!
  void __garbage_stop_editing() {
    if ( ! j.isEditing() ) return;
    Object e = j.getCellEditor();
    if ( e instanceof StdCellEditor ) {
      //JOptionPane.showMessageDialog(null, "garbage edit...");
      (( StdCellEditor ) e).force_stopCellEditing();
      return;
    }
    if ( e instanceof DefaultCellEditor ) {
      //JOptionPane.showMessageDialog(null, "garbage edit combo...");
      //(( DefaultCellEditor ) e).stopCellEditing();
      (( DefaultCellEditor ) e).cancelCellEditing();
      return;
    }
  }

}

class CHTabelaSocios extends CHTabela {
	
}

// NO SE PODE EVITAR A CPIA  ???
class CHTabelaPrint extends CHTabela {

  public int print_rows;
  public int row_offset = 0;

  CHTabelaPrint ( CHTabela org ) {
    j = org.j;
    width = org.width;
    //col_name = org.col_name;
    //col_width = org.col_width;
    d = org.d;
    //vld = org.vld;
    //editable = org.editable;

    // PRINT-NEW : copiar cdx
    this.cdx = org.cdx;

    print_rows = org.getRowCount();
    //JOptionPane.showMessageDialog( null, "Inicialmente so linhas: " + Integer.toString( print_rows ));
  }

  public int getRowCount() {
    return print_rows;
  }

  public Object getValueAt(int i, int j) {
    i = i + row_offset;
    if (  i >= d.dados.size() ) return "";
    return super.getValueAt(i, j);
  }

  /*
  public JTableHeader getTableHeader () {
    JTableHeader th = new JTableHeader( j.getColumnModel());

    TableColumn c;
    int i;
    for (i = 0; i < col_width.length; i++) {
      c = th.getColumnModel().getColumn(i);
      c.setPreferredWidth(col_width[i]);
    }
    j.repaint();

    return th;
  }
  */
}

//------------------------------------------------------------------------------
// CHTabelaFixed
//------------------------------------------------------------------------------
//FILIPA
// MAL : parte deveria estar em CB
class CHTabQuadro extends CHTabela {

  CFType[] row_vld;
  boolean[] row_editable;
  String [] row_autocalc;

  CHTabQuadro () {
    super();
  }

  // ! depois de reset dados !!!
  void start_rows() {
    int n = d.dados.size();
    row_vld = new CFType[n];
    row_editable = new boolean[n];
    row_autocalc = new String[n];
    for ( int i = 0; i < n; i++ ) {
      row_vld[i] = null;
      row_editable[i] = true;
      row_autocalc[i] = null;
    }
  }

  public void setValueAt(Object v, int i, int j) {

    //JOptionPane.showMessageDialog(null, "setValueAt- Quadro "+ i+ " - "+j );

    String s = (String) v;
    j = cdx[j];
    CFType col_vld = d.cols[j].vld;
    boolean ok = true;
    if (s.length() == 0) {
      ( (String[]) d.dados.elementAt(i))[j] = s;
      //return;
    }

    else if (row_vld[i] != null) {
      //JOptionPane.showMessageDialog(null, "da linha " + i);
      ok = row_vld[i].setText(s);
      if ( ok )
        ( (String[]) d.dados.elementAt(i))[j] = row_vld[i].getString();
      //return;
    }

    else if (col_vld != null) {
      ok = col_vld.setText(s);
      if ( ok )
        ( (String[]) d.dados.elementAt(i))[j] = col_vld.getString();
      //return;
    }
    else ( (String[]) d.dados.elementAt(i))[j] = s;

    CBData.setDirty();
    d.on_update( d.cols[j].col_tag, i, s );

  }

  public Object getValueAt(int i, int j) {
    j = cdx[j];
    CFType col_vld = d.cols[j].vld;
    String s = ((String[]) d.dados.elementAt(i))[j];
    //JOptionPane.showMessageDialog( null, "i = " + i + "; j = " + j);

    if ( d.cols[j].editable && row_vld[i] != null) {
      row_vld[i].setString(s);
      s = row_vld[i].getText();
    }

    else if (col_vld != null) {
      col_vld.setString(s);
      s = col_vld.getText();
    }
    return s;
  }

  public boolean isCellEditable(int i, int j) {
    j = cdx[j];
    return row_editable[i] && d.cols[j].editable;
  }

  public boolean isRowEditable(int i) {
    return row_editable[i];
  }

  public boolean isColEditable(int j) {
    j = cdx[j];
    return d.cols[j].editable;
  }

  public boolean valOnline (Object v, int i, int j) {

    j = cdx[j];
    CFType vld = d.cols[j].vld;
    String s = (String) v;

    //JOptionPane.showMessageDialog(null, "Validar: " + s );

    boolean ok = true;
    if (s.length() == 0) {
      return true;
    }

    else if (row_vld[i] != null) {
      //JOptionPane.showMessageDialog(null, "vld da linha " + i);
      ok = row_vld[i].setText(s);
      return ok;
    }
    else if (vld != null) {
      //JOptionPane.showMessageDialog(null, "ponto chave ?");
      ok = vld.setText(s);
      return ok;
    }
    return true;
  }

}


//------------------------------------------------------------------------------
// InputVerifier
//------------------------------------------------------------------------------

class CHCampo_InputVerifier extends InputVerifier {

  static CHCampo editing = null;

  public CHCampo_InputVerifier() {
  }

  public boolean verify(JComponent jcomp) {
    //String tag = (String) jcomp.getClientProperty("tag")
    jcomp.setInputVerifier(null);
    //boolean ok = CBData.FTB.vldOnline(tag);
    //JOptionPane.showMessageDialog( null, "input verifier...");
    CHCampo c = (CHCampo) jcomp.getClientProperty("handler");
    boolean ok = c.vldOnline();
    //JOptionPane.showMessageDialog(null, "Validao: " + ok);
    jcomp.setInputVerifier(this);
    if ( ! ok ) editing = c;
    if ( ok ) editing = null;
    return ok;
  }

}
