package fme;

import javax.swing.*;
import javax.swing.tree.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.plaf.ColorUIResource;
import java.awt.Dimension;
import java.util.Vector;

import java.awt.event.ActionEvent;


class CHValid {

  static int n_erros = 0;
  static int n_avisos = 0;

  static DefaultMutableTreeNode root = null;
  CHValid() {
  }

  static void reset( String _s) {
    root = new DefaultMutableTreeNode( _s );
    n_erros = 0;
    n_avisos = 0;
  }

  static void add_grp ( CHValid_Grp grp ) {
    if ( grp.getChildCount() > 0 ) root.add(grp);
  }

  static void add_pg_grp ( CHValid_Grp grp ) {
    if ( grp == null ) return;
    grp.grp_tipo = 'P';
    add_grp(grp);
  }

  static String show (boolean global) {
    /*String s = "";
    if (global)
      s = "Validaes Globais";
    else
      s = "Validaes da Pgina";*/
    if ( root.isLeaf() ) {
      //JOptionPane.showMessageDialog(null, "No foram detectados erros.", s, 1);
      return "-";
    }
    Dialog_Valid d = new Dialog_Valid( root, n_erros, n_avisos, global );
    return d.cmd;
  }
}

interface CBData_Comum {
  void locate ( CHValid_Msg msg );
  String getPagina();
  String getParam (String param);
  void on_external_update ( String tag);
}

class CHValid_Grp extends DefaultMutableTreeNode {
  CBData_Comum handler;
  String title;
  int msg_count = 0;
  int err_count = 0;
  char grp_tipo;

  CHValid_Grp ( String _title ) {
    handler = null;
    title = _title;
  }

  CHValid_Grp ( CBData_Comum _handler, String _title ) {
    super( _title);
    handler = _handler;
    title = _title;
    grp_tipo = 'G';
  }

  void add_msg ( CHValid_Msg msg ) {
    this.add( msg );
    msg_count++;
    if ( msg.tipo == 'E' ) CHValid.n_erros++;
    if ( msg.tipo == 'W' ) CHValid.n_avisos++;
    if ( msg.tipo == 'E' ) err_count++;
  }

  void add_grp ( CHValid_Grp grp ) {
    if ( grp == null ) return;
    if ( grp.msg_count > 0) this.add(grp);
  }

  public String toString() {
    return title;
  }

}

class CHValid_Msg extends DefaultMutableTreeNode {
  String tag;
  char tipo;
  int row, col;

  CHValid_Msg ( String _tag, char _tipo, String _msg ) {
    super ( _msg.replaceAll( "%o" , "Preenchimento Obrigatrio"));
    tag = _tag;
    tipo = _tipo;
    row = -1; col = -1;
  }

  // por compatibilidade...
  CHValid_Msg ( String _tag, String _msg ) {
    super ( _msg.replaceAll( "%o" , "Preenchimento Obrigatrio"));
    tag = _tag;
    tipo = 'E';
    row = -1; col = -1;
  }


  CHValid_Msg ( String _tag, String _msg, int _row, int _col ) {
    super ( _msg.replaceAll( "%o" , "Preenchimento Obrigatrio"));
    tag = _tag;
    tipo = 'E';
    row = _row; col = _col;
  }

}


class Dialog_Valid extends JDialog {

  JPanel contentPane;
  JButton cmdGo;
  JButton cmdSair;
  JButton cmdConfirmar;
  public String form;
  public String campo;
  public int row;
  public int col;
  public int erros;
  public int avisos;
  public boolean global;
  DefaultMutableTreeNode root;
  JLabel lblErro = new JLabel();
  JLabel lblAviso = new JLabel();
  JScrollPane scrollPane = new JScrollPane();
  private JTree tree;
  JLabel label = new JLabel();
  int nodes_total = 0;
  JPanel pnl = new JPanel();

  String cmd = "";

  public static ImageIcon inserirLinha = new ImageIcon(fme.fmeFrame.class.getResource("inserirlinha.gif"));
  public static ImageIcon copiarLinha = new ImageIcon(fme.fmeFrame.class.getResource("copiarlinha.gif"));
  public static ImageIcon erroIcon = new ImageIcon(fme.fmeFrame.class.getResource("erro.gif")); //erros
  public static ImageIcon avisoIcon = new ImageIcon(fme.fmeFrame.class.getResource("aviso.gif")); //avisos

  public Dialog_Valid( DefaultMutableTreeNode _root, int _erros, int _avisos, boolean _global ) {
    try {
      root = _root;
      erros = _erros;
      avisos = _avisos;
      global = _global;
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    JPanel contentPane = (JPanel)getContentPane();
    contentPane.setLayout(null);
    form = null;
    campo = null;

    cmdGo = new JButton();
    cmdSair = new JButton();
    cmdConfirmar = new JButton();

    cmdGo.setMaximumSize(new Dimension(77, 27));
    cmdGo.setMinimumSize(new Dimension(77, 27));
    cmdGo.setPreferredSize(new Dimension(77, 27));
    cmdGo.setText("Ir at ao quadro");
    cmdGo.setBounds(new Rectangle(330, 17, 110, 30));
    cmdGo.addActionListener(new Dialog_Valid_jButton_Go_actionAdapter(this));
    cmdGo.setMargin(new Insets(1,1,1,1));

    cmdSair.setMnemonic('n');
    cmdSair.setText("Sair");
    cmdSair.setBounds(new Rectangle(450, 17, 110, 30));
    cmdSair.addActionListener(new Dialog_Valid_jButton_Close_actionAdapter(this));

    lblErro.setBounds(new Rectangle(5, 13, 80, 36));
    lblErro.setIcon(erroIcon);
    lblErro.setVerticalTextPosition(SwingConstants.CENTER);
    lblErro.setVerticalAlignment(SwingConstants.CENTER);
    lblErro.setHorizontalTextPosition(SwingConstants.RIGHT);
    lblErro.setHorizontalAlignment(SwingConstants.LEFT);

    lblAviso.setBounds(new Rectangle(85, 13, 80, 36));
    lblAviso.setIcon(avisoIcon);
    lblAviso.setVerticalTextPosition(SwingConstants.CENTER);
    lblAviso.setVerticalAlignment(SwingConstants.CENTER);
    lblAviso.setHorizontalTextPosition(SwingConstants.RIGHT);
    lblAviso.setHorizontalAlignment(SwingConstants.LEFT);

    scrollPane.setBorder(BorderFactory.createEtchedBorder());
    scrollPane.setBounds(new Rectangle(4, 12, 560, 272));
    pnl.setLayout(null);
    pnl.setBounds(new Rectangle(3, 275, 561, 50));

    tree = new JTree(root);
    tree.getSelectionModel().setSelectionMode(TreeSelectionModel.
                                              SINGLE_TREE_SELECTION);
    tree.setBackground(new Color(212, 208, 200));
    tree.setOpaque(false);
    tree.setShowsRootHandles(true); //pe o (-) antes da raz
    tree.setRowHeight(0);
    tree.setSelectionRow(0);
    tree.setScrollsOnExpand(true);
    tree.setRootVisible(true);
    tree.setLargeModel(true);
    tree.putClientProperty("JTree.lineStyle", "Horizontal");
    tree.setCellRenderer(new MyTreeRenderer());
    tree.addMouseListener(new Dialog_Valid_tree_mouseAdapter(this));
    expandAll(root);

    setTitle("Validaes - Lista de Erros e Avisos");
    lblErro.setText(erros + " Erro" + (erros != 1 ? "s" : ""));
    lblAviso.setText(avisos + " Aviso" + (avisos != 1 ? "s" : ""));
    contentPane.add(scrollPane, "North");
    scrollPane.getViewport().add(tree);
    contentPane.add(pnl, "South");
    //if ( global ) pnl.add(cmdGo, "East");
    pnl.add(cmdSair, null);
    pnl.add(lblErro, null);
    pnl.add(lblAviso, null);
    setModal(true);
    setResizable(false);
    setSize(575, 355);
    setLocation(Toolkit.getDefaultToolkit().getScreenSize().width / 2 -
                getSize().width / 2,
                Toolkit.getDefaultToolkit().getScreenSize().height / 2 -
                getSize().height / 2);
    setVisible(true);
  }

  void tree_mouseClicked(MouseEvent e) {
    if (e.getClickCount() == 2)
      vaiAteForm ();
  }

  private void expandAll(TreeNode tNode) {
    TreePath tp = new TreePath( ( (DefaultMutableTreeNode) tNode).getPath());
    tree.expandPath(tp);
    for (int i = 0; i < tNode.getChildCount(); i++)
      expandAll(tNode.getChildAt(i));
  }

  void jButton_Close_actionPerformed(ActionEvent e) {
    this.cmd = "X";
    this.hide();
  }

  void jButton_Go_actionPerformed(ActionEvent e) {
    vaiAteForm ();
  }

  void vaiAteForm(){
    DefaultMutableTreeNode s = (DefaultMutableTreeNode) tree.getLastSelectedPathComponent();
    if (s == null)return;
    if (s instanceof CHValid_Msg) {
      CHValid_Grp h = (CHValid_Grp) s.getParent();
      h.handler.locate( (CHValid_Msg) s);
      this.cmd = "G";
      this.hide();
    }
  }
}


class MyTreeRenderer implements TreeCellRenderer {
  public MyTreeRenderer() {
    theTextArea = new TreeTextArea();
    theLabel = new JLabel();
    thePanel = new JPanel();
    theLabel.setOpaque(false);
    theTextArea.setOpaque(false);
    thePanel.setOpaque(false);
    thePanel.add(theLabel, "West");
    thePanel.add(theTextArea, "West");
  }

  public Component getTreeCellRendererComponent(JTree tree, Object value,
                                                boolean selected,
                                                boolean expanded, boolean leaf,
                                                int row, boolean hasFocus) {

    Icon raizIcon = new ImageIcon(fme.fmeFrame.class.getResource("form_icon.gif")); //erros
    Icon paginaIcon = new ImageIcon(fme.fmeFrame.class.getResource("pagina.gif")); //avisos
    Icon grupoIcon = new ImageIcon(fme.fmeFrame.class.getResource("grupo.png")); //grupos
    Icon erroIcon = new ImageIcon(fme.fmeFrame.class.getResource("erro.gif")); //erros
    Icon avisoIcon = new ImageIcon(fme.fmeFrame.class.getResource("aviso.gif")); //avisos

    theTextArea.setText(value.toString());

    if (selected) {
      thePanel.setOpaque(true);
      //thePanel.setBackground(fmeFrame.rosa_cinza);
      //thePanel.setBackground(new Color(90,145,211));
      thePanel.setBackground(new Color(146,182,226));
      theTextArea.setForeground(Color.white);
    }
    else {
      thePanel.setOpaque(false);
      theTextArea.setForeground(tree.getForeground());
    }

    if ( value instanceof DefaultMutableTreeNode ) {
      theLabel.setIcon(raizIcon);
      theTextArea.setFont(fmeFrame.letra_bold);
    }
    if (value instanceof CHValid_Grp) {
      theTextArea.setFont(fmeFrame.letra_bold);
      char tipo = ( (CHValid_Grp) (value)).grp_tipo;
      if (tipo == 'G') theLabel.setIcon(grupoIcon);
      if (tipo == 'P') theLabel.setIcon(paginaIcon);
      theTextArea.setFont(fmeFrame.letra_bold);
    }
    if (value instanceof CHValid_Msg){
      if (((CHValid_Msg) value).tipo == 'E') theLabel.setIcon(erroIcon);
      else theLabel.setIcon(avisoIcon);
      theTextArea.setFont(fmeFrame.letra);
    }

    return thePanel;
  }

  public Dimension getPreferredSize() {
    return new Dimension(thePanel.getPreferredSize());
  }

  protected JLabel theLabel;
  protected TreeTextArea theTextArea;
  protected JPanel thePanel;
}

class TreeTextArea extends JTextArea {
  TreeTextArea() {
    setLineWrap(true);
    setWrapStyleWord(true);
    setOpaque(true);
  }

  public void setBackground(Color color) {
    if (color instanceof ColorUIResource)
      color = null;
    super.setBackground(color);
  }

  public void setPreferredSize(Dimension d) {
    if (d != null)
      preferredSize = d;
  }

  public Dimension getPreferredSize() {
    return preferredSize;
  }

  public void setText(String str) {
	  //JOptionPane.showMessageDialog(null, str);
    Vector resultado = new Vector();
    int maxWidth = 415;
    JPanel pn = new JPanel();
    FontMetrics fm = pn.getFontMetrics(getFont());
    resultado = quebraLinhas(getFont(), str, maxWidth);
    int lines = resultado.toArray().length;
    lines = lines >= 1 ? lines : 1;
    int height = fm.getHeight() * lines;
    setPreferredSize(new Dimension(maxWidth+6, height));
    str = "";
    for (int i = 0; i < lines; i++ ){
      str += resultado.elementAt(i);
    }
    super.setText(str);
  }

  void setSelect(boolean isSelected) {
    Color bColor;
    if (isSelected)
      bColor = UIManager.getColor(Color.GREEN);
    else
      bColor = UIManager.getColor(Color.BLUE);
    super.setBackground(bColor);
  }

  void setFocus(boolean hasFocus) {
    if (hasFocus) {
      Color lineColor = UIManager.getColor("Tree.selectionBorderColor");
      setBorder(BorderFactory.createLineBorder(lineColor));
    }
    else {
      setBorder(BorderFactory.createEmptyBorder(1, 1, 1, 1));
    }
  }

  public Vector quebraLinhas(Font fonte, String texto, int largura) {
    Vector resultado = new Vector();
    JPanel metrica = new JPanel();
    if (fonte == null || texto == null || texto.length() == 0)
      return resultado;
    if (largura <= 0)
      largura = 415;
    String esta = "";
    String anterior = "";
    if (texto.lastIndexOf("\n") < 0) {
      for (StringTokenizer trataString = new StringTokenizer(texto);
           trataString.hasMoreTokens(); ) {
        String parte = trataString.nextToken();
        if (esta.length() == 0)
          esta = parte;
        else
          esta = esta + " " + parte;
        if (metrica.getFontMetrics(fonte).stringWidth(esta) > largura ) {
          resultado.addElement(new String(anterior + "\n"));
          esta = parte;
        }
        anterior = esta;
      }

      if (anterior.length() > 0)
        resultado.addElement(new String(anterior + "\n"));
    }
    else {
      for (StringTokenizer trataString = new StringTokenizer(texto, "\n");
           trataString.hasMoreTokens();
           resultado.addElement(new String(trataString.nextToken())));
    }
    return resultado;
  }
  Dimension preferredSize;
}


class Dialog_Valid_jButton_Close_actionAdapter implements java.awt.event.ActionListener {
  Dialog_Valid adaptee;

  Dialog_Valid_jButton_Close_actionAdapter(Dialog_Valid adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Close_actionPerformed(e);
  }
}

class Dialog_Valid_jButton_Go_actionAdapter implements java.awt.event.ActionListener {
  Dialog_Valid adaptee;

  Dialog_Valid_jButton_Go_actionAdapter(Dialog_Valid adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Go_actionPerformed(e);
  }
}

class Dialog_Valid_tree_mouseAdapter implements java.awt.event.MouseListener {
  Dialog_Valid adaptee;

  Dialog_Valid_tree_mouseAdapter(Dialog_Valid adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseClicked(MouseEvent e) {
    adaptee.tree_mouseClicked(e);
  }

  public void mousePressed(MouseEvent e) {
  }

  public void mouseReleased(MouseEvent e) {
  }

  public void mouseEntered(MouseEvent e) {
  }

  public void mouseExited(MouseEvent e) {
  }
}




